/**
 * Application config file
 */

// Bryntum umd lite bundle comes without polyfills to support Angular's zone.js
import { AssignmentModel, AssignmentStore, EventModel, ResourceModel, SchedulerConfig, EventStore } from '@bryntum/scheduler';

const resources = [
    new ResourceModel({
        id       : 1,
        name     : 'Alfonso'
    }),
    new ResourceModel({
        id         : 2,
        name       : 'Pepe'
    }),
    new ResourceModel({
        id         : 3,
        name       : 'Manue'
    })
]

// let event1 = new EventModel();
// event1.id = 1;
// event1.resourceId = 1;
// event1.startDate = new Date(2017, 0, 1, 10);
// event1.endDate = new Date(2017, 0, 1, 12);
// event1.name = 'First Task';
// event1.iconCls = 'b-fa b-fa-mouse-pointer';

// const events: EventModel[] = [event1];

const events = [
    new EventModel({
        id         : 1,
        // resourceId : 1,
        startDate  : new Date(2017, 0, 1, 10),
        endDate    : new Date(2017, 0, 1, 12),
        name       : 'First Task',
        iconCls    : 'b-fa b-fa-mouse-pointer'
    }),
    new EventModel({
        id         : 2,
        // resourceId : 2,
        startDate  : new Date(2017, 0, 1, 12),
        endDate    : new Date(2017, 0, 1, 13, 30),
        name       : 'Lunch Break',
        iconCls    : 'b-fa b-fa-arrows-alt'
    })
]; // Doesn't attach events to resources

const assignments = [
    new AssignmentModel({
        resourceId: 1,
        eventId : 1
    })
]

// const events = [
//     {
//         id         : 1,
//         resourceId : 1,
//         startDate  : new Date(2017, 0, 1, 10),
//         endDate    : new Date(2017, 0, 1, 12),
//         name       : 'First Task',
//         iconCls    : 'b-fa b-fa-mouse-pointer'
//     },
//     {
//         id         : 2,
//         resourceId : 2,
//         startDate  : new Date(2017, 0, 1, 12),
//         endDate    : new Date(2017, 0, 1, 13, 30),
//         name       : 'Lunch Break',
//         iconCls    : 'b-fa b-fa-arrows-alt'
//     }
// ]; // Works and attach events to resources

export const schedulerConfig: Partial<SchedulerConfig> = {
    resourceStore : {
        modelClass : ResourceModel,
    },
    eventStore : {
        modelClass : EventModel,
    },
    startDate        : new Date(2017, 0, 1, 6),
    endDate          : new Date(2017, 0, 1, 20),
    viewPreset       : 'hourAndDay',
    rowHeight        : 50,
    barMargin        : 5,
    multiEventSelect : true,
    // project: {
    //     resourceModelClass: ResourceModel,
    //     eventModelClass: EventModel
    //   }, // How does this work? Is it mandatory in cases where an event model can morph into different classes?
            // ie: eventModelClass:  schedulerEventModel -> because depending on our needs, scheduler will be populated with shiftEventModel or dayOffEventModel

    columns : [
        { text : 'Name', field : 'name', width : 130 }
    ],

    features : {
        eventEdit       : false,
        simpleEventEdit : true
    }
};
